<script lang="ts">
	import Chip from './Chip.svelte'
	import { createEventDispatcher } from 'svelte'
	interface Props {
		style?: string;
		accentColour?: string;
		items?: string[];
		allowDuplicates?: boolean;
		manualAdd?: boolean;
	}

	let {
		style = '',
		accentColour = '#d891ff',
		items = $bindable([]),
		allowDuplicates = false,
		manualAdd = true
	}: Props = $props();

	const dispatch = createEventDispatcher()

	function addNewItem(e: CustomEvent<any>) {
		if (!e.detail.text) return
		const lowerText = e.detail.text.toLowerCase()
		if (!allowDuplicates && items.find((o) => o && o.toString().toLowerCase() === lowerText)) return
		items.push(e.detail.text)
		items = items
		dispatch('change', { items })
    dispatch('add', {item: e.detail.text})
	}

	function deleteItem(e: CustomEvent<{ text: string }>) {
		const index = items.findIndex((o) => o.toString() === e.detail.text)
		if (index === -1) return
		items.splice(index, 1)
		items = items
		dispatch('change', { items })
    dispatch('remove', {item: e.detail.text})
	}
</script>

<div style="display: flex; flex-wrap: wrap; {style}">
	{#each items as item (item)}
		<Chip {accentColour} text={item} on:click={deleteItem} />
	{/each}
  {#if manualAdd}
	<Chip {accentColour} addState={true} on:click={addNewItem} />
  {/if}
</div>